package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.TSSDTask;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class TSSDTaskSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<TSSDTask> selectCond;
	private JSONObject customsearchval;
	public TSSDTaskSearchFilter(){
		this.page =new Page<TSSDTask>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<TSSDTask>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_tssdengineid_eq;

	public void setN_tssdengineid_eq(String n_tssdengineid_eq) {
        this.n_tssdengineid_eq = n_tssdengineid_eq;
        if(!StringUtils.isEmpty(this.n_tssdengineid_eq)){
            this.selectCond.eq("tssdengineid", n_tssdengineid_eq);
        }
    }
	private String n_tssdenginename_eq;

	public void setN_tssdenginename_eq(String n_tssdenginename_eq) {
        this.n_tssdenginename_eq = n_tssdenginename_eq;
        if(!StringUtils.isEmpty(this.n_tssdenginename_eq)){
            this.selectCond.eq("tssdenginename", n_tssdenginename_eq);
        }
    }
	private String n_tssdenginename_like;

	public void setN_tssdenginename_like(String n_tssdenginename_like) {
        this.n_tssdenginename_like = n_tssdenginename_like;
        if(!StringUtils.isEmpty(this.n_tssdenginename_like)){
            this.selectCond.like("tssdenginename", n_tssdenginename_like);
        }
    }
	private String n_tssdtaskname_like;

	public void setN_tssdtaskname_like(String n_tssdtaskname_like) {
        this.n_tssdtaskname_like = n_tssdtaskname_like;
        if(!StringUtils.isEmpty(this.n_tssdtaskname_like)){
            this.selectCond.like("tssdtaskname", n_tssdtaskname_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_TSSDTASK_TSSDENGINE_TSSDENGINEID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_tssdengineid_eq("NA");
			}
			else{
				this.setN_tssdengineid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("tssdtaskname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}